OGRE: Ogre::GLSLShader Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::GLSLShader Class Reference

Specialisation of HighLevelGpuProgram to encapsulate shader objects obtained from compiled shaders written in the OpenGL Shader Language (GLSL). More...

`#include <OgreGLSLShader.h>`

Inheritance diagram for Ogre::GLSLShader:
[legend]

## Classes
class | CmdAttach
| Command object for attaching another GLSL Program. More...
class | CmdColumnMajorMatrices
| Command object for setting matrix packing in column-major order. More...
class | CmdInputOperationType
| Command object for setting the input operation type (geometry shader only) More...
class | CmdMaxOutputVertices
| Command object for setting the maximum output vertices (geometry shader only) More...
class | CmdOutputOperationType
| Command object for setting the output operation type (geometry shader only) More...
class | CmdPreprocessorDefines
| Command object for setting macro defines. More...

## Public Types
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| GLSLShader (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader)
| ~GLSLShader ()
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
GpuProgram * | _getBindingDelegate (void)
| Since GLSL has no assembly, use this shader for binding. More...
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
void | attachChildShader (const String &name)
| Attach another GLSL Shader to this one. More...
void | attachToProgramObject (const GLuint programObject)
void | bind (void)
| Bind the shader in OpenGL. More...
void | bindParameters (GpuProgramParametersSharedPtr params, uint16 mask)
| Execute the param binding functions for this shader. More...
void | bindPassIterationParameters (GpuProgramParametersSharedPtr params)
| Execute the pass iteration param binding functions for this shader. More...
void | bindSharedParameters (GpuProgramParametersSharedPtr params, uint16 mask)
| Execute the shared param binding functions for this shader. More...
size_t | calculateSize (void) const
| Calculate the size of a resource; this will only be called after 'load'. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
bool | compile (const bool checkErrors=false)
| Compile source into shader object. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
GpuProgramParametersSharedPtr | createParameters (void)
| Overridden from GpuProgram. More...
void | detachFromProgramObject (const GLuint programObject)
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
String | getAttachedShaderNames () const
bool | getBuildParametersFromReflection (void) const
bool | getColumnMajorMatrices (void) const
| Gets whether matrix packed in column-major order. More...
virtual Vector3 | getComputeGroupDimensions (void) const
| Returns the number of process groups dispatched by this compute program. More...
const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of GpuConstantDefinition instances. More...
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
virtual GpuProgramParametersSharedPtr | getDefaultParameters (void)
| Get a reference to the default parameters which are to be used for all uses of this program. More...
bool | getEnableIncludeHeader (void) const
GLuint | getGLProgramHandle ()
GLuint | getGLShaderHandle () const
GLenum | getGLShaderType (GpuProgramType programType)
| Get OpenGL GLSL shader type from OGRE GPU program type. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
virtual OperationType | getInputOperationType (void) const
| Returns the operation type that this geometry program expects to receive as input. More...
const String & | getLanguage (void) const
| Overridden from GpuProgram. More...
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself. More...
virtual int | getMaxOutputVertices (void) const
| Returns the maximum number of vertices that this geometry program can output in a single run. More...
virtual const String & | getName (void) const
| Gets resource name. More...
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation. More...
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
virtual OperationType | getOutputOperationType (void) const
| Returns the operation type that this geometry program will emit. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
bool | getPassFogStates (void) const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override) More...
bool | getPassSurfaceAndLightStates (void) const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override) More...
bool | getPassTransformStates (void) const
| Overridden. More...
const String & | getPreprocessorDefines (void) const
| Sets the preprocessor defines use to compile the program. More...
GLuint | getShaderID (void) const
| Get the OGRE assigned shader ID. More...
String | getShaderTypeLabel (GpuProgramType programType)
| Get a string containing the name of the GLSL shader type correspondening to the OGRE GPU program type. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
virtual const String & | getSource (void) const
| Gets the assembler source for this program. More...
virtual const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program. More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
virtual const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g. More...
virtual GpuProgramType | getType (void) const
| Get the program type. More...
virtual bool | hasCompileError (void) const
| Did this program encounter a compile error when loading? More...
virtual bool | hasDefaultParameters (void) const
| Returns true if default parameters have been set up. More...
virtual bool | isAdjacencyInfoRequired (void) const
| Returns whether this geometry program requires adjacency information from the input primitives. More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
GLint | isLinked (void)
| Return the shader link status. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isMorphAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform morph animation. More...
virtual bool | isPoseAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform pose animation. More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
virtual bool | isSkeletalAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform skeletal animation. More...
virtual bool | isSupported (void) const
| Returns whether this program can be supported on the current renderer and hardware. More...
virtual bool | isVertexTextureFetchRequired (void) const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware. More...
virtual bool | isVpAndRtArrayIndexFromAnyShaderRequired (void) const
| Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one. More...
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
virtual void | resetCompileError (void)
| Reset a compile error if it occurred, allowing the load to be retried. More...
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
void | setBuildParametersFromReflection (bool buildParams)
void | setColumnMajorMatrices (bool columnMajor)
| Sets whether matrix packing in column-major order. More...
virtual void | setComputeGroupDimensions (Vector3 dimensions)
| Sets the number of process groups dispatched by this compute program. More...
void | setEnableIncludeHeader (bool bEnable)
| Whether we should parse the source code looking for include files and embedding the file. More...
virtual void | setInputOperationType (OperationType operationType)
| Sets the operation type that this geometry program expects to receive. More...
void | setLinked (GLint flag)
| Set the shader link status. More...
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?". More...
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself. More...
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself. More...
virtual void | setMaxOutputVertices (int maxOutputVertices)
| Set the maximum number of vertices that a single run of this geometry program can emit. More...
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation. More...
virtual void | setOutputOperationType (OperationType operationType)
| Set the operation type that this geometry program will emit. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation. More...
void | setPreprocessorDefines (const String &defines)
| Sets the preprocessor defines use to compile the program. More...
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation. More...
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string. More...
virtual void | setSource (const String &source, const String &debugFilename)
| Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e. More...
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program. More...
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g. More...
virtual void | setToLoaded (void)
| Change the Resource loading state to loaded. More...
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load) More...
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware. More...
virtual void | setVpAndRtArrayIndexFromAnyShaderRequired (bool r)
| Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
void | unbind (void)
| Unbind the shader in OpenGL. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...
static void | unbindAll (void)

## Public Attributes
| OGRE_AUTO_MUTEX

## Static Public Attributes
static CmdEnableIncludeHeader | msEnableIncludeHeaderCmd

## Detailed Description

Specialisation of HighLevelGpuProgram to encapsulate shader objects obtained from compiled shaders written in the OpenGL Shader Language (GLSL).

Remarks
  GLSL has no target assembler or entry point specification like DirectX 9 HLSL. Vertex and Fragment shaders only have one entry point called "main". When a shader is compiled, microcode is generated but can not be accessed by the application. GLSL also does not provide assembler low level output after compiling. The GL Render system assumes that the Gpu program is a GL GPU program so GLSLShader will create a GL3PlusShader for the low level implementation. The GLSLShader class will create a shader object and compile the source but will not create a program object. It's up to GL3PlusShader class to request a program object to link the shader object to.

Note
  GLSL supports multiple modular shader objects that can be attached to one program object to form a single shader. This is supported through the "attach" material script command. All the modules to be attached are listed on the same line as the attach command separated by white space.

## Member Enumeration Documentation

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags
| inherited

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## ◆ LoadingState

enum Ogre::Resource::LoadingState
| inherited

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## Constructor & Destructor Documentation

## ◆ GLSLShader()

Ogre::GLSLShader::GLSLShader | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader
| ) |  |

## ◆ ~GLSLShader()

Ogre::GLSLShader::~GLSLShader | ( |  | ) |

## Member Function Documentation

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtualinherited

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |
| virtualinherited

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ _getBindingDelegate()

GpuProgram* Ogre::GLSLShader::_getBindingDelegate | ( | void |  | ) |
| inlinevirtual

Since GLSL has no assembly, use this shader for binding.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ _notifyOrigin()

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inlinevirtualinherited

Notify this resource of it's origin.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtualinherited

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ attachChildShader()

void Ogre::GLSLShader::attachChildShader | ( | const String & | name | ) |

Attach another GLSL Shader to this one.

## ◆ attachToProgramObject()

void Ogre::GLSLShader::attachToProgramObject | ( | const GLuint | programObject | ) |

## ◆ bind()

void Ogre::GLSLShader::bind | ( | void |  | ) |

Bind the shader in OpenGL.

## ◆ bindParameters()

void Ogre::GLSLShader::bindParameters | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask
| ) |  |

Execute the param binding functions for this shader.

## ◆ bindPassIterationParameters()

void Ogre::GLSLShader::bindPassIterationParameters | ( | GpuProgramParametersSharedPtr | params | ) |

Execute the pass iteration param binding functions for this shader.

## ◆ bindSharedParameters()

void Ogre::GLSLShader::bindSharedParameters | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask
| ) |  |

Execute the shared param binding functions for this shader.

## ◆ calculateSize()

size_t Ogre::GLSLShader::calculateSize | ( | void |  | ) | const
| virtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtualinherited

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ compile()

bool Ogre::GLSLShader::compile | ( | const bool | checkErrors = `false` | ) |

Compile source into shader object.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ createParameters()

GpuProgramParametersSharedPtr Ogre::GLSLShader::createParameters | ( | void |  | ) |
| virtual

Overridden from GpuProgram.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ detachFromProgramObject()

void Ogre::GLSLShader::detachFromProgramObject | ( | const GLuint | programObject | ) |

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtualinherited

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getAttachedShaderNames()

String Ogre::GLSLShader::getAttachedShaderNames | ( |  | ) | const
| inline

## ◆ getBuildParametersFromReflection()

bool Ogre::GpuProgram::getBuildParametersFromReflection | ( | void |  | ) | const
| inlineinherited

## ◆ getColumnMajorMatrices()

bool Ogre::GLSLShader::getColumnMajorMatrices | ( | void |  | ) | const
| inline

Gets whether matrix packed in column-major order.

## ◆ getComputeGroupDimensions()

virtual Vector3 Ogre::GpuProgram::getComputeGroupDimensions | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of process groups dispatched by this compute program.

## ◆ getConstantDefinitions()

const GpuNamedConstants& Ogre::HighLevelGpuProgram::getConstantDefinitions | ( |  | ) | const
| virtualinherited

Get the full list of GpuConstantDefinition instances.

Note
  Only available if this parameters object has named parameters.

Reimplemented from Ogre::GpuProgram.

## ◆ getCreator()

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inlinevirtualinherited

Gets the manager which created this resource.

## ◆ getDefaultParameters()

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::getDefaultParameters | ( | void |  | ) |
| virtualinherited

Get a reference to the default parameters which are to be used for all uses of this program.

Remarks
  A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getEnableIncludeHeader()

bool Ogre::HighLevelGpuProgram::getEnableIncludeHeader | ( | void |  | ) | const
| inherited

## ◆ getGLProgramHandle()

GLuint Ogre::GLSLShader::getGLProgramHandle | ( |  | ) |

## ◆ getGLShaderHandle()

GLuint Ogre::GLSLShader::getGLShaderHandle | ( |  | ) | const
| inline

## ◆ getGLShaderType()

GLenum Ogre::GLSLShader::getGLShaderType | ( | GpuProgramType | programType | ) |

Get OpenGL GLSL shader type from OGRE GPU program type.

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inlinevirtualinherited

Gets the group which this resource is a member of.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getInputOperationType()

virtual OperationType Ogre::GLSLShader::getInputOperationType | ( | void |  | ) | const
| inlinevirtual

Returns the operation type that this geometry program expects to receive as input.

## ◆ getLanguage()

const String& Ogre::GLSLShader::getLanguage | ( | void |  | ) | const
| virtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inlinevirtualinherited

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ getManualNamedConstantsFile()

virtual const String& Ogre::GpuProgram::getManualNamedConstantsFile | ( |  | ) | const
| inlinevirtualinherited

Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

## ◆ getMaxOutputVertices()

virtual int Ogre::GLSLShader::getMaxOutputVertices | ( | void |  | ) | const
| inlinevirtual

Returns the maximum number of vertices that this geometry program can output in a single run.

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inlinevirtualinherited

Gets resource name.

Reimplemented in Ogre::v1::OldSkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName().

## ◆ getNumberOfPosesIncluded()

virtual ushort Ogre::GpuProgram::getNumberOfPosesIncluded | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getOrigin()

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inlinevirtualinherited

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ getOutputOperationType()

virtual OperationType Ogre::GLSLShader::getOutputOperationType | ( | void |  | ) | const
| inlinevirtual

Returns the operation type that this geometry program will emit.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getPassFogStates()

bool Ogre::GLSLShader::getPassFogStates | ( | void |  | ) | const
| virtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)

Remarks
  On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassSurfaceAndLightStates()

bool Ogre::GLSLShader::getPassSurfaceAndLightStates | ( | void |  | ) | const
| virtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)

Remarks
  Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ getPassTransformStates()

bool Ogre::GLSLShader::getPassTransformStates | ( | void |  | ) | const
| virtual

Overridden.

Reimplemented from Ogre::GpuProgram.

## ◆ getPreprocessorDefines()

const String& Ogre::GLSLShader::getPreprocessorDefines | ( | void |  | ) | const
| inline

Sets the preprocessor defines use to compile the program.

## ◆ getShaderID()

GLuint Ogre::GLSLShader::getShaderID | ( | void |  | ) | const
| inline

Get the OGRE assigned shader ID.

## ◆ getShaderTypeLabel()

String Ogre::GLSLShader::getShaderTypeLabel | ( | GpuProgramType | programType | ) |

Get a string containing the name of the GLSL shader type correspondening to the OGRE GPU program type.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inlinevirtualinherited

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getSource()

virtual const String& Ogre::GpuProgram::getSource | ( | void |  | ) | const
| inlinevirtualinherited

Gets the assembler source for this program.

## ◆ getSourceFile()

virtual const String& Ogre::GpuProgram::getSourceFile | ( | void |  | ) | const
| inlinevirtualinherited

Gets the name of the file used as source for this program.

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inlinevirtualinherited

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ getSyntaxCode()

virtual const String& Ogre::GpuProgram::getSyntaxCode | ( | void |  | ) | const
| inlinevirtualinherited

Gets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ getType()

virtual GpuProgramType Ogre::GpuProgram::getType | ( | void |  | ) | const
| inlinevirtualinherited

Get the program type.

## ◆ hasCompileError()

virtual bool Ogre::GpuProgram::hasCompileError | ( | void |  | ) | const
| inlinevirtualinherited

Did this program encounter a compile error when loading?

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ hasDefaultParameters()

virtual bool Ogre::GpuProgram::hasDefaultParameters | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if default parameters have been set up.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::SharedPtr< T >::isNull().

## ◆ isAdjacencyInfoRequired()

virtual bool Ogre::GpuProgram::isAdjacencyInfoRequired | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this geometry program requires adjacency information from the input primitives.

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isLinked()

GLint Ogre::GLSLShader::isLinked | ( | void |  | ) |
| inline

Return the shader link status.

Only used for separable programs.

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inlinevirtualinherited

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Is this resource manually loaded?

## ◆ isMorphAnimationIncluded()

virtual bool Ogre::GpuProgram::isMorphAnimationIncluded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether a vertex program includes the required instructions to perform morph animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isPoseAnimationIncluded()

virtual bool Ogre::GpuProgram::isPoseAnimationIncluded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether a vertex program includes the required instructions to perform pose animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been prepared, false otherwise.

References Ogre::AtomicScalar< T >::get().

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isSkeletalAnimationIncluded()

virtual bool Ogre::GpuProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether a vertex program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isSupported()

virtual bool Ogre::GpuProgram::isSupported | ( | void |  | ) | const
| virtualinherited

Returns whether this program can be supported on the current renderer and hardware.

Reimplemented in Ogre::D3D9HLSLProgram, Ogre::D3D11HLSLProgram, and Ogre::UnifiedHighLevelGpuProgram.

## ◆ isVertexTextureFetchRequired()

virtual bool Ogre::GpuProgram::isVertexTextureFetchRequired | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isVpAndRtArrayIndexFromAnyShaderRequired()

virtual bool Ogre::GpuProgram::isVpAndRtArrayIndexFromAnyShaderRequired | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtualinherited

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::v1::Mesh.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtualinherited

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ resetCompileError()

virtual void Ogre::GpuProgram::resetCompileError | ( | void |  | ) |
| inlinevirtualinherited

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setAdjacencyInfoRequired()

virtual void Ogre::GpuProgram::setAdjacencyInfoRequired | ( | bool | r | ) |
| inlinevirtualinherited

Sets whether this geometry program requires adjacency information from the input primitives.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inlinevirtualinherited

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setBuildParametersFromReflection()

void Ogre::GpuProgram::setBuildParametersFromReflection | ( | bool | buildParams | ) |
| inlineinherited

## ◆ setColumnMajorMatrices()

void Ogre::GLSLShader::setColumnMajorMatrices | ( | bool | columnMajor | ) |
| inline

Sets whether matrix packing in column-major order.

## ◆ setComputeGroupDimensions()

virtual void Ogre::GpuProgram::setComputeGroupDimensions | ( | Vector3 | dimensions | ) |
| inlinevirtualinherited

Sets the number of process groups dispatched by this compute program.

## ◆ setEnableIncludeHeader()

void Ogre::HighLevelGpuProgram::setEnableIncludeHeader | ( | bool | bEnable | ) |
| inherited

Whether we should parse the source code looking for include files and embedding the file.

Disabled by default to avoid slowing down when #include is not used. Not needed if the API natively supports it (D3D11).

Remarks
  Single line comments are supported: #include "MyFile.h" --> won't be included.

              Block comment lines are not supported, but may not matter if
              the included file does not close the block:
                  / *
                      #include "MyFile.h" --> file will be included anyway.
                    /

              Preprocessor macros are not supported, but should not matter:
                  #if SOME_MACRO
                      #include "MyFile.h" --> file will be included anyway.
                  #endif
          @par
              Recursive includes are supported (e.g. header includes a header)
          @par
              Beware included files mess up error reporting (wrong lines)
          @param bEnable
              True to support #include. Must be toggled before loading the source file.

## ◆ setInputOperationType()

virtual void Ogre::GLSLShader::setInputOperationType | ( | OperationType | operationType | ) |
| inlinevirtual

Sets the operation type that this geometry program expects to receive.

## ◆ setLinked()

void Ogre::GLSLShader::setLinked | ( | GLint | flag | ) |
| inline

Set the shader link status.

Only used for separable programs.

## ◆ setManuallyLoaded()

virtual void Ogre::Resource::setManuallyLoaded | ( | bool | isManual | ) |
| inlinevirtualinherited

Set "Is this resource manually loaded?".

## ◆ setManualNamedConstants()

virtual void Ogre::GpuProgram::setManualNamedConstants | ( | const GpuNamedConstants & | namedConstants | ) |
| virtualinherited

Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.

Remarks
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source.

See also
  setManualNamedConstantsFile

## ◆ setManualNamedConstantsFile()

virtual void Ogre::GpuProgram::setManualNamedConstantsFile | ( | const String & | paramDefFile | ) |
| virtualinherited

Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

Remarks
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source. This method will make a low-level program search in the resource group of the program for the named file from which to load parameter names from. The file must be in the format produced by GpuNamedConstants::save.

## ◆ setMaxOutputVertices()

virtual void Ogre::GLSLShader::setMaxOutputVertices | ( | int | maxOutputVertices | ) |
| inlinevirtual

Set the maximum number of vertices that a single run of this geometry program can emit.

## ◆ setMorphAnimationIncluded()

virtual void Ogre::GpuProgram::setMorphAnimationIncluded | ( | bool | included | ) |
| inlinevirtualinherited

Sets whether a vertex program includes the required instructions to perform morph animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

## ◆ setOutputOperationType()

virtual void Ogre::GLSLShader::setOutputOperationType | ( | OperationType | operationType | ) |
| inlinevirtual

Set the operation type that this geometry program will emit.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setPoseAnimationIncluded()

virtual void Ogre::GpuProgram::setPoseAnimationIncluded | ( | ushort | poseCount | ) |
| inlinevirtualinherited

Sets whether a vertex program includes the required instructions to perform pose animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Parameters

  poseCount | The number of simultaneous poses the program can blend

## ◆ setPreprocessorDefines()

void Ogre::GLSLShader::setPreprocessorDefines | ( | const String & | defines | ) |
| inline

Sets the preprocessor defines use to compile the program.

## ◆ setSkeletalAnimationIncluded()

virtual void Ogre::GpuProgram::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inlinevirtualinherited

Sets whether a vertex program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ setSource() [1/2]

virtual void Ogre::GpuProgram::setSource | ( | const String & | source | ) |
| virtualinherited

Sets the source assembly for this program from an in-memory string.

Remarks
  Setting this will have no effect until you (re)load the program.

## ◆ setSource() [2/2]

virtual void Ogre::GpuProgram::setSource | ( | const String & | source,
|  | const String & | debugFilename
| ) |  |
| virtualinherited

Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.

Visual Studio Graphics Debugger)

Parameters

  source | Shader source code
  debugFilename | Optional Path to this file. Can be left blank.

## ◆ setSourceFile()

virtual void Ogre::GpuProgram::setSourceFile | ( | const String & | filename | ) |
| virtualinherited

Sets the filename of the source assembly for this program.

Remarks
  Setting this will have no effect until you (re)load the program.

## ◆ setSyntaxCode()

virtual void Ogre::GpuProgram::setSyntaxCode | ( | const String & | syntax | ) |
| virtualinherited

Sets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ setToLoaded()

virtual void Ogre::Resource::setToLoaded | ( | void |  | ) |
| inlinevirtualinherited

Change the Resource loading state to loaded.

References Ogre::AtomicScalar< T >::set().

## ◆ setType()

virtual void Ogre::GpuProgram::setType | ( | GpuProgramType | t | ) |
| virtualinherited

Set the program type (only valid before load)

## ◆ setVertexTextureFetchRequired()

virtual void Ogre::GpuProgram::setVertexTextureFetchRequired | ( | bool | r | ) |
| inlinevirtualinherited

Sets whether this vertex program requires support for vertex texture fetch from the hardware.

## ◆ setVpAndRtArrayIndexFromAnyShaderRequired()

virtual void Ogre::GpuProgram::setVpAndRtArrayIndexFromAnyShaderRequired | ( | bool | r | ) |
| inlinevirtualinherited

Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtualinherited

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## ◆ unbind()

void Ogre::GLSLShader::unbind | ( | void |  | ) |

Unbind the shader in OpenGL.

## ◆ unbindAll()

static void Ogre::GLSLShader::unbindAll | ( | void |  | ) |
| static

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtualinherited

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## Member Data Documentation

## ◆ msEnableIncludeHeaderCmd

CmdEnableIncludeHeader Ogre::HighLevelGpuProgram::msEnableIncludeHeaderCmd
| staticinherited

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreGLSLShader.h